#include "SD_card.h"

#define CS  15
#define diviseur  2

File myFile;
static char last_datestamp[2][20];

void init_SD(void) {
  Serial.print("Initializing SD card...");
  if (!SD.begin(CS)) {
    Serial.println("initialization failed!");
    return;
  }
  Serial.println("initialization done.");
  last_datestamp[0][0] = '\0';
  last_datestamp[1][0] = '\0';
}

void enreg_temp(int num_sonde, int temp, char* datestamp) {
  char filename[15];
  //enregistre au max 1 par minute par sonde.
  int new_time = 0;
  for (int i = 0; i < 16; i++) {
    if (datestamp[i] != last_datestamp[num_sonde - 1][i]) {
      new_time = 1;
    }
  }
  if (!new_time) {
    return;
  }
  for (int i = 0; i < 16; i++) {
    last_datestamp[num_sonde - 1][i] = datestamp[i];
  }
  strncpy(filename, datestamp, 4);
  filename[4] = datestamp[5];
  filename[5] = datestamp[6];
  filename[6] = datestamp[8];
  filename[7] = datestamp[9];
  filename[8] = '.';
  filename[9] = 'l';
  filename[10] = 'o';
  filename[11] = 'g';
  filename[12] = '\0';
  myFile = SD.open(filename, FILE_WRITE);
  myFile.print(datestamp[11]);
  myFile.print(datestamp[12]);
  myFile.print(':');
  myFile.print(datestamp[14]);
  myFile.print(datestamp[15]);
  myFile.print('-');
  myFile.print(num_sonde);
  myFile.print('-');
  Serial.print("tf:");
  sprintf(datestamp, "%03d", temp); //formattage 3 digits mais ne marche pas pour les négatifs
  Serial.println(datestamp);
  myFile.println(datestamp);
  myFile.close();
}

int liste_dates(char liste[][13]) {
  //renvois les 100 dernierres dates
  int valide = 1;
  int nb_date = 0;
  int i = 0;
  //vide la table
  for(i=0;i<100;i++){
    strncpy(liste[i], "            \0", 13);
  }
  myFile = SD.open("/");
  myFile.rewindDirectory();
  while (valide) {
    File entry = myFile.openNextFile();
    if (entry) {
      //on cherche le point d'insertion.
      for(nb_date=0;nb_date<100;nb_date++){
        if (strtol (entry.name(),NULL,10) > strtol (liste[nb_date],NULL,10))
          break;
      }
      for(i=98;i>=nb_date;i--) //on décalle les suivant
      {
        strncpy(liste[i+1], liste[i], 13);
      }
      strncpy(liste[nb_date], entry.name(), 12);  //on insere
      liste[nb_date][12] = '\0';
      entry.close();
    }
    else {
      valide = 0;
    }
  }
  myFile.close();
  return 100;
}

int lit_temp(char* jour, Siplec* sondes) {
  //renvoie le max de temp lus
  int i = 0;
  int u, nb_s1 = 0, nb_s2 = 0, num_sonde;
  double last_temp[2];
  double temp_moyenne[2][4];
  double temperature;
  char ligne[14];
  //reset des historiques de sonde :
  sondes[0].NbHist = nb_s1/4;
  sondes[1].NbHist = nb_s2/4;

  myFile = SD.open(jour, FILE_READ);
  if (myFile) {
    while (myFile.available()) {
      u = 0;
      while (myFile.available()) { //lit une ligne
        ligne[u] = myFile.read();
        if (ligne[u] == '\n') {
          ligne[13] = '\0';
          break;
        }
        u++;
      }
      //traite la ligne lue
      num_sonde =  ligne[6] - 48 - 1;
      if (ligne[8] == '-') {        //temperature négative
        temperature = (ligne[9] - 48) * -10;
        temperature -= (ligne[10] - 48) * 1;
        //temperature -= ligne[11]-48;
      }
      else {                        //temperature positive
        temperature = (ligne[8] - 48) * 100;
        temperature += (ligne[9] - 48) * 10;
        temperature += ligne[10] - 48;
      }
      if ((nb_s2 / 4) > nb_histo | (nb_s1 / 4) > nb_histo) {
        exit;
      }
      /*debug
      if(num_sonde==0){
        Serial.print("s:");
        Serial.print(num_sonde);
        Serial.print("t:");
        i = temperature;
        Serial.println(temperature);  
      }*/
      //init de la 1er temperature pour filtre ejecteur, moyenneur et +1 pour bypass le filtre "identique"
      if (nb_s1 == 0)
      {
        last_temp[0] = temperature + 1;
        temp_moyenne[0][3] =  temp_moyenne[0][2] =  temp_moyenne[0][1] = temperature;
      }
      if (nb_s2 == 0)
      {
        last_temp[1] = temperature + 1;
        temp_moyenne[1][3] =  temp_moyenne[1][2] =  temp_moyenne[1][1] = temperature;
      }

      if ((temperature > last_temp[num_sonde] - 3) & (temperature < last_temp[num_sonde] + 3)) //on vire les "extremes"
      {
        //on moyenne les 4 dernieres valeurs
        temp_moyenne[num_sonde][3] = temp_moyenne[num_sonde][2];
        temp_moyenne[num_sonde][2] = temp_moyenne[num_sonde][1];
        temp_moyenne[num_sonde][1] = temp_moyenne[num_sonde][0];
        temp_moyenne[num_sonde][0] = temperature;
        temp_moyenne[num_sonde][3] += temp_moyenne[num_sonde][2] + temp_moyenne[num_sonde][1] + temp_moyenne[num_sonde][0];
        temp_moyenne[num_sonde][3] = temp_moyenne[num_sonde][3] / 40;

        if (temperature != last_temp[num_sonde])    //on ne rajoute pas de point si température identique
        {
          if (num_sonde == 1) {
            sondes[num_sonde].NbHist = nb_s2/diviseur;
            sondes[num_sonde].set_value((temp_moyenne[num_sonde][3]), (nb_s2) / diviseur); //on ne garde qu'une mesure sur "diviseur"
            sondes[num_sonde].set_timestamp(ligne, (nb_s2++) / diviseur);
          }
          else if (num_sonde == 0) {
            sondes[num_sonde].NbHist = nb_s1/diviseur;
            sondes[num_sonde].set_value((temp_moyenne[num_sonde][3]), (nb_s1) / diviseur); //on ne garde qu'une mesure sur "diviseur"
            sondes[num_sonde].set_timestamp(ligne, (nb_s1++) / diviseur);
          }
          last_temp[num_sonde] = temperature;
        }
      }
      else //correction pondéré de last_temp pour éviter une ejection de toutes les data
      {
        last_temp[num_sonde] = (last_temp[num_sonde] *3 + temperature) / 4;
      }      
      i++;
    }
    myFile.close();
  }
  if (nb_s1 > nb_s2){
    return nb_s1/diviseur;
  }
  else{
    return nb_s2/diviseur;
  }
}
