#include "Serveur.h"

chart chartjs;
WiFiServer server(80);

void init_serveur(void) {
  server.begin();
  Serial.println("Server started on");
  Serial.println(WiFi.localIP());
}

void Poll_client(Siplec* capteurs, int nb_capteur) {
  WiFiClient client = server.available();
  if (client) {
    Serial.println("new client");// an http request ends with a blank line
    boolean currentLineIsBlank = true;
    boolean receiveEOL = false;
    char receiveCommand[250];
    int rxChar = 0;
    while (client.connected()) {
      if (client.available()) {
        char c = client.read();
        if (c == '\n' ) {
          receiveEOL = true;
        }
        if (!receiveEOL)
        {
          receiveCommand[rxChar++] = c;
        }
        Serial.write(c);
        // if you've gotten to the end of the line (received a newline
        // character) and the line is blank, the http request has ended,
        // so you can send a reply
        if (c == '\n' && currentLineIsBlank) {
          receiveEOL = false;
          Serial.write(receiveCommand, rxChar - 1);
          Serial.write('\n');
          switch (receiveCommand[5]) {
            case 'i' :  
              chartjs.index(client);
              break;
            case 'c' :
              chartjs.get_script(client);
              break;
            case 'm' :
              chartjs.show_list(client);
              chartjs.charge_date(receiveCommand, capteurs);
              chartjs.get_chart(client, capteurs, nb_capteur);
              break;
            case 'l' :
              chartjs.show_list(client);
              break;
            default :
              client.println("404");
          }
          break;
        }
        if (c == '\n') {
          // you're starting a new line
          currentLineIsBlank = true;
        }
        else if (c != '\r') {
          // you've gotten a character on the current line
          currentLineIsBlank = false;
        }
      }
    }
    // give the web browser time to receive the data
    delay(1);
    // close the connection:
    client.stop();
    Serial.println("client disonnected");
  }
}

