/*-------------------------------------------------------------------------------------
 * Marche bien avec la version 2.0.0 du board manager esp8266
 * la version 2.1.0 provoque des reset intempestif par rapport aux interuptions !
 */

#include <ESP8266WiFi.h>
#include <WiFiUdp.h>

//#include "capteur.h"
#include "wifi.h"
#include "NTP_client.h"
#include "Siplec433.h"
#include "Serveur.h"

// librayry des .h -----
#include <Time.h>
#include <SPI.h>
#include <SD.h>

Siplec sonde_1(nb_histo);
Siplec sonde_2(nb_histo);
Siplec capteurs[2] = {sonde_1, sonde_2};

void setup() {
  Serial.begin(115200);
  //Serial.setDebugOutput(true);
  Serial.println();
  Serial.println("init");
  init_wifi();  
  init_SD();
  init_NTP();
  init_433();
  init_serveur();

  //test capteurs
  for (int i = 0; i < nb_histo; i++){
    sonde_1.set_value(i-10,i);
    sonde_2.set_value(i-5,i);
  }
}

void loop() {
  char timenow[20];
  int nb_date;
  // put your main code here, to run repeatedly:
//Serial.print("Heap : ");
//Serial.println(ESP.getFreeHeap());
  delay(100);
  if(is_new_temp() != 0){
    timenow[0] = ' ';
    while(timenow[0] == ' '){
      get_time(timenow);
    }
    Serial.println(timenow);
    Serial.println(is_new_temp());  
    if (timenow[0] != ' '){
      enreg_temp(is_new_temp(),get_temp(),timenow);  
    }
    Serial.print("t:");
    Serial.println(get_temp());
  }
  //serveur web
  Poll_client(capteurs, 2);  
}
